<?php

namespace App\Http\Controllers;

use App\Models\Turno;
use App\Models\Plantel;
use Illuminate\Http\Request;
use Illuminate\Routing\Controller;

class TurnoController extends Controller
{

    public function __construct() {
        $this->middleware('can:turno.index')->only('index','show');
        $this->middleware('can:turno.create')->only('create','store');
        $this->middleware('can:turno.edit')->only('edit','update');
        $this->middleware('can:turno.destroy')->only('destroy');
    }

    public function index()
    {
        $turnos = Turno::all();
        return view('turno.index',compact('turnos'));
    }

    public function create()
    {
        $plantels = Plantel::where('status','=','1')->get();
        return view('turno.create',compact('plantels'));
    }


    public function store(Request $request)
    {
        $request->validate([
            'name'=>'required'
        ]);

        $turno = Turno::create($request->except(['plantels']));
        $turno->turnoPlantel()->sync($request->plantels);
        return redirect()->route('turno.edit',$turno)->with('info','El turno se creo correctamente');
    }


    public function show(Turno $turno)
    {

        return view('turno.show',compact('turno'));
    }


    public function edit(Turno $turno)
    {
        $plantels = Plantel::where('status','=','1')->get();
        return view('turno.edit',compact('turno','plantels'));
    }


    public function update(Request $request, Turno $turno)
    {
        $turno->update($request->except(['plantels']));
        $turno->turnoPlantel()->sync($request->plantels);
        return redirect()->route('turno.edit',$turno)->with('info','El turno se actualizo correctamente');
    }

    public function destroy(Turno $turno)
    {
        $turno->delete();
        session()->flash('swal',[
            'icon'=>'success',
            'title'=>'Eliminado!',
            'text'=>'Se ha eliminado el registro correctamente'
        ]);
        return redirect()->route('turno.index');
    }
}
